Index: /trunk/gsdl/packages/mg-1.3d/acconfig.h
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/acconfig.h	(revision 30)
+++ /trunk/gsdl/packages/mg-1.3d/acconfig.h	(revision 30)
@@ -0,0 +1,35 @@
+/* Special definitions for mg, processed by autoheader.
+   Created by [TS:Aug/95] 
+   by grepping for AC_DEFINE on configure.in and using the appropriate defs 
+   of acconfig.h used by GNU tar.
+*/
+
+/* Define to the name of the distribution.  */
+#undef PACKAGE
+
+/* Define to the version of the distribution.  */
+#undef VERSION
+
+/* Define if `union wait' is the type of the first arg to wait functions.  */
+#undef HAVE_UNION_WAIT
+
+/* Define to 1 if you have the valloc function.  */
+#undef HAVE_VALLOC
+
+/* Define to 1 if ANSI function prototypes are usable.  */
+#undef PROTOTYPES
+ 
+/* Define to 1 for better use of the debugging malloc library.  See
+   site ftp.antaire.com in antaire/src, file dmalloc/dmalloc.tar.gz.  */
+#undef WITH_DMALLOC
+ 
+/* Define to 1 if GNU regex should be used instead of GNU rx.  */
+#undef WITH_REGEX
+
+/* Some braindead header files do not have the requ'd function declarations */
+#undef HAVE_FGETC_DECL
+#undef HAVE_FREAD_DECL
+
+/* See if have this field in the prstatus_t structure */
+/* It stores the size of the process heap */
+#undef HAVE_PR_BRKSIZE
Index: /trunk/gsdl/packages/mg-1.3d/config.h.in
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/config.h.in	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/config.h.in	(revision 30)
@@ -52,7 +52,7 @@
    direction of stack growth for your system; otherwise it will be
    automatically deduced at run-time.
-	STACK_DIRECTION > 0 => grows toward higher addresses
-	STACK_DIRECTION < 0 => grows toward lower addresses
-	STACK_DIRECTION = 0 => direction of growth unknown
+ STACK_DIRECTION > 0 => grows toward higher addresses
+ STACK_DIRECTION < 0 => grows toward lower addresses
+ STACK_DIRECTION = 0 => direction of growth unknown
  */
 #undef STACK_DIRECTION
@@ -99,4 +99,7 @@
 #undef HAVE_FTIME
 
+/* Define if you have the ftruncate function.  */
+#undef HAVE_FTRUNCATE
+
 /* Define if you have the getpagesize function.  */
 #undef HAVE_GETPAGESIZE
@@ -114,6 +117,12 @@
 #undef HAVE_SETBUFFER
 
+/* Define if you have the strcasecmp function.  */
+#undef HAVE_STRCASECMP
+
 /* Define if you have the strftime function.  */
 #undef HAVE_STRFTIME
+
+/* Define if you have the strstr function.  */
+#undef HAVE_STRSTR
 
 /* Define if you have the strtol function.  */
Index: /trunk/gsdl/packages/mg-1.3d/lib/WIN32.MAK
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/WIN32.MAK	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/lib/WIN32.MAK	(revision 30)
@@ -31,5 +31,5 @@
 #CFLAGS = -g -O 
 CPPFLAGS = 
-DEFS = -DHAVE_CONFIG_H -D__WIN32__ -D_LITTLE_ENDIAN
+DEFS = -DQUIET -DHAVE_CONFIG_H -D__WIN32__ -D_LITTLE_ENDIAN
  
 COMPILE = $(CC) -c $(DEFS) -I. -I..
@@ -53,6 +53,6 @@
     bitio_m_mem.h      bitio_random.h     huffman_mem.h      perf_hash.h \
     bitio_m_mems.h     bitio_stdio.h      huffman_stdio.h    sptree.h \
-    regex.h            rx.h               pathmax.h          getpagesize.h \
-    random.h
+                       rx.h               pathmax.h          getpagesize.h \
+    random.h           win32in.h          frenchstem.h
 
 SOURCES = \
@@ -62,9 +62,10 @@
     bitio_mem.c       getopt.c          huffman_stdio.c   sptree.c \
     bitio_mems.c      getopt1.c         local_strings.c   stem.c \
-    timing.c          regex.c           rx.c              \
+    timing.c                            rx.c              \
     alloca.c          error.c           xmalloc.c         strstr.c \
-    ftruncate.c       strcasecmp.c      random.c          
+    ftruncate.c       strcasecmp.c      random.c          win32in.c \
+    frenchstem.c
 
-OBJECTS =   rx.obj \
+OBJECTS =   rx$o \
     bitio_random$o    heap$o            memlib$o \
     bitio_stdio$o     huffman$o         messages$o \
@@ -72,7 +73,7 @@
     bitio_mem$o       getopt$o          huffman_stdio$o   sptree$o \
     bitio_mems$o      getopt1$o         local_strings$o   stem$o \
-    timing$o          regex$o \
+    timing$o           \
     error$o           xmalloc$o \
-    random$o
+    random$o          win32in$o         frenchstem$o
  
 DISTFILES = Makefile.in $(HEADERS) $(SOURCES)
@@ -101,8 +102,8 @@
 
 mostlyclean:
-	rm -f *.o *_.o
+	del *.obj
  
 clean: mostlyclean
-	rm -f libmg.lib
+	del libmg.lib
  
 distclean: clean
Index: /trunk/gsdl/packages/mg-1.3d/lib/alloca.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/alloca.c	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/lib/alloca.c	(revision 30)
@@ -26,5 +26,5 @@
 #  include <win32cfg.h>
 # else
-#  include <config.h>
+#  include <sysfuncs.h>
 # endif
 #endif
Index: /trunk/gsdl/packages/mg-1.3d/lib/error.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/error.c	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/lib/error.c	(revision 30)
@@ -22,5 +22,5 @@
 #  include <win32cfg.h>
 # else
-#  include <config.h>
+#  include <sysfuncs.h>
 # endif
 #endif
Index: /trunk/gsdl/packages/mg-1.3d/lib/frenchstem.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/frenchstem.c	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/lib/frenchstem.c	(revision 30)
@@ -1,28 +1,61 @@
+/**************************************************************************
+ *
+ * frenchstem.c -- a simple french stemmer
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ * $Id$
+ *
+ **************************************************************************/
 
-static char * frenchstem (word)
-char *word;
-{      
-  int len = strlen(word)-1;
-  if (len > 4) {
-    if (word[len]=='x') {
-      if (word[len-1]=='u' && word[len-2]=='a') {
-	word[len-1]='l';
+#include "frenchstem.h"
+
+
+
+/* =========================================================================
+ * Function: frenchstem
+ * Description: a simple french stemmer
+ * Input: a word string with the length in the first byte
+ * Output: the stemmed word
+ * ========================================================================= */
+
+void frenchstem (unsigned char *word) {      
+  unsigned char *wordstart = word + 1; /* points to first letter of word */
+  int last = (int)word[0]-1;           /* last points to the last character */
+
+  if (last > 4) {
+    if (wordstart[last]=='x') {
+      if (wordstart[last-1]=='u' && wordstart[last-2]=='a') {
+	wordstart[last-1]='l';
       }
-      word[len]='\0';
-      return(word);
-    }
-    else {
-      if (word[len]=='s')
-	{word[len]='\0';len--;}
-      if (word[len]=='r')
-	{word[len]='\0';len--;}
-      if (word[len]=='e')
-	{word[len]='\0';len--;}
-      if (word[len]=='é')    /* letter with accent e + ' */
-	{word[len]='\0';len--;}
-      if (word[len] == word[len-1])
-	word[len]='\0';
+      wordstart[last]='\0';
+      last--;
+
+    } else {
+      if (wordstart[last]=='s' && last>=0) 
+	{wordstart[last]='\0'; last--;}
+      if (wordstart[last]=='r' && last>=0)
+	{wordstart[last]='\0'; last--;}
+      if (wordstart[last]=='e' && last>=0)
+	{wordstart[last]='\0'; last--;}
+      if (wordstart[last]=='é' && last>=0) /* letter with accent e + ' */
+	{wordstart[last]='\0'; last--;}
+      if (wordstart[last]==wordstart[last-1] && last>=1)
+	{wordstart[last]='\0'; last--;}
     }  /* end else */
+
+    word[0] = (unsigned char)(last+1);
   } /* end if (len > 4) */
-  return(word);
 }
Index: /trunk/gsdl/packages/mg-1.3d/lib/frenchstem.h
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/frenchstem.h	(revision 30)
+++ /trunk/gsdl/packages/mg-1.3d/lib/frenchstem.h	(revision 30)
@@ -0,0 +1,37 @@
+/**************************************************************************
+ *
+ * frenchstem.h -- a simple french stemmer
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ * $Id$
+ *
+ **************************************************************************/
+
+/*
+   $Log$
+   Revision 1.1  1998/11/24 06:37:53  rjmcnab
+
+   Incorporated the french stemmer better.
+
+
+ */
+
+#ifndef FRENCH_STEM_H
+#define FRENCH_STEM_H
+
+void frenchstem (unsigned char *word);
+
+#endif
Index: /trunk/gsdl/packages/mg-1.3d/lib/ftruncate.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/ftruncate.c	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/lib/ftruncate.c	(revision 30)
@@ -6,5 +6,5 @@
 #  include <win32cfg.h>
 # else
-#  include <config.h>
+#  include <sysfuncs.h>
 # endif
 #endif
Index: /trunk/gsdl/packages/mg-1.3d/lib/getopt.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/getopt.c	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/lib/getopt.c	(revision 30)
@@ -23,5 +23,5 @@
 
 #ifdef HAVE_CONFIG_H
-#include "config.h"
+#include "sysfuncs.h"
 #endif
 
Index: /trunk/gsdl/packages/mg-1.3d/lib/getopt1.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/getopt1.c	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/lib/getopt1.c	(revision 30)
@@ -19,5 +19,5 @@
 
 #ifdef HAVE_CONFIG_H
-#include "config.h"
+#include "sysfuncs.h"
 #endif
 
Index: /trunk/gsdl/packages/mg-1.3d/lib/gmalloc.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/gmalloc.c	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/lib/gmalloc.c	(revision 30)
@@ -34,5 +34,5 @@
 
 #ifdef	HAVE_CONFIG_H
-#include <config.h>
+#include <sysfuncs.h>
 #endif
 
Index: /trunk/gsdl/packages/mg-1.3d/lib/messages.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/messages.c	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/lib/messages.c	(revision 30)
@@ -24,6 +24,10 @@
 /*
    $Log$
-   Revision 1.1  1998/11/17 09:32:14  rjmcnab
-   *** empty log message ***
+   Revision 1.2  1998/11/23 03:38:06  rjmcnab
+
+   combined unix and windows versions of mg
+
+   Revision 1.1  1998/11/19 03:00:32  sjboddie
+   Added windows gdbm and mg versions
 
    * Revision 1.1  1994/08/22  00:24:48  tes
@@ -72,4 +76,9 @@
   char *s, *pfx;
   va_list args;
+
+#ifdef QUIET
+  return; /* stop those messages!!!! */
+#endif  
+
   va_start (args, fmt);
   vsprintf (buf, fmt, args);
Index: /trunk/gsdl/packages/mg-1.3d/lib/regex.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/regex.c	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/lib/regex.c	(revision 30)
@@ -31,5 +31,5 @@
 #  include <win32cfg.h>
 # else
-#  include <config.h>
+#  include <sysfuncs.h>
 # endif
 #endif
@@ -57,5 +57,5 @@
 /* If we are not linking with Emacs proper,
    we can't use the relocating allocator
-   even if config.h says that we can.  */
+   even if sysfuncs.h says that we can.  */
 #undef REL_ALLOC
 
@@ -160,8 +160,10 @@
    eliminate the && through constant folding."  */
 
-#if defined (STDC_HEADERS) || (!defined (isascii) && !defined (HAVE_ISASCII))
-#define ISASCII(c) 1
-#else
-#define ISASCII(c) isascii(c)
+#ifndef ISASCII
+#  if defined (STDC_HEADERS) || (!defined (isascii) && !defined (HAVE_ISASCII))
+#    define ISASCII(c) 1
+#  else
+#    define ISASCII(c) isascii(c)
+#  endif
 #endif
 
@@ -966,5 +968,5 @@
 
 /* When using GNU C, we are not REALLY using the C alloca, no matter
-   what config.h may say.  So don't take precautions for it.  */
+   what sysfuncs.h may say.  So don't take precautions for it.  */
 #ifdef __GNUC__
 #undef C_ALLOCA
Index: /trunk/gsdl/packages/mg-1.3d/lib/rx.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/rx.c	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/lib/rx.c	(revision 30)
@@ -36,5 +36,5 @@
 #  include <malloc.h>
 # else
-#  include <config.h>
+#  include <sysfuncs.h>
 # endif
 #endif
Index: /trunk/gsdl/packages/mg-1.3d/lib/rx.h
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/rx.h	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/lib/rx.h	(revision 30)
@@ -2185,5 +2185,5 @@
  * that make sense only in Emacs. 
  */
-#include "config.h"
+#include "sysfuncs.h"
 #include "lisp.h"
 #include "buffer.h"
Index: /trunk/gsdl/packages/mg-1.3d/lib/win32in.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/win32in.c	(revision 30)
+++ /trunk/gsdl/packages/mg-1.3d/lib/win32in.c	(revision 30)
@@ -0,0 +1,72 @@
+/* This module provides an equivalent of <netinet/in.h> on  */
+/* unix systems. */
+
+unsigned long htonl(unsigned long x) {
+#if defined (LITTLE_ENDIAN) || defined (_LITTLE_ENDIAN) || defined(__LITTLE_ENDIAN)
+	x = ((x >> 24) & 0x000000FF) | ((x >> 8) & 0x0000FF00) |
+		((x << 8) & 0x00FF0000) | ((x << 24) & 0xFF000000);
+#endif
+
+	return x;
+}
+
+unsigned long ntohl(unsigned long x) {
+#if defined (LITTLE_ENDIAN) || defined (_LITTLE_ENDIAN) || defined(__LITTLE_ENDIAN)
+	x = ((x >> 24) & 0x000000FF) | ((x >> 8) & 0x0000FF00) |
+		((x << 8) & 0x00FF0000) | ((x << 24) & 0xFF000000);
+#endif
+	return x;
+}
+
+unsigned short htons(unsigned short x) {
+#if defined (LITTLE_ENDIAN) || defined (_LITTLE_ENDIAN) || defined(__LITTLE_ENDIAN)
+	x = ((x >> 8) & 0x00FF) | ((x << 8) & 0xFF00);
+#endif
+	return x;
+}
+
+unsigned short ntohs(unsigned short x) {
+#if defined (LITTLE_ENDIAN) || defined (_LITTLE_ENDIAN) || defined(__LITTLE_ENDIAN)
+	x = ((x >> 8) & 0x00FF) | ((x << 8) & 0xFF00);
+#endif
+	return x;
+}
+
+/* just to test stuff
+#include <stdio.h>
+
+main () {
+	long x;
+	short sx;
+
+	x = 0x000000FF;
+	printf ("before %i, ",(int)x);
+	x = htonl (x);
+	printf ("after %i\n",(int)x);
+
+	x = 0x0000FF00;
+	printf ("before %i, ",(int)x);
+	x = htonl (x);
+	printf ("after %i\n",(int)x);
+
+	x = 0x00FF0000;
+	printf ("before %i, ",(int)x);
+	x = htonl (x);
+	printf ("after %i\n",(int)x);
+
+	x = 0xFF000000;
+	printf ("before %i, ",(int)x);
+	x = htonl (x);
+	printf ("after %i\n\n",(int)x);
+
+	sx = 0x00FF;
+	printf ("before %i, ",(int)sx);
+	sx = htons (sx);
+	printf ("after %i\n",(int)sx);
+
+	sx = 0xFF00;
+	printf ("before %i, ",(int)sx);
+	sx = htons (sx);
+	printf ("after %i\n",(int)sx);
+}
+*/
Index: /trunk/gsdl/packages/mg-1.3d/lib/xmalloc.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/lib/xmalloc.c	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/lib/xmalloc.c	(revision 30)
@@ -20,5 +20,5 @@
 #  include <win32cfg.h>
 # else
-#  include <config.h>
+#  include <sysfuncs.h>
 # endif
 #endif
Index: /trunk/gsdl/packages/mg-1.3d/src/text/MGPASS.C
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/src/text/MGPASS.C	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/src/text/MGPASS.C	(revision 30)
@@ -49,4 +49,12 @@
 /*
    $Log$
+   Revision 1.3  1998/11/24 03:39:23  rjmcnab
+
+   Fixed a small error in the windows compilation
+
+   Revision 1.2  1998/11/24 01:29:39  rjmcnab
+
+   Fixed a few problems with the windows build
+
    Revision 1.1  1998/11/17 09:34:12  rjmcnab
    *** empty log message ***
@@ -82,7 +90,7 @@
 FILE *Comp_Stats = NULL;
 int comp_stat_point = 0;
-u_long bytes_processed = 0;
+double bytes_processed = 0;
 int num_docs = 0;
-u_long bytes_received = 0;
+double bytes_received = 0;
 int stem_method = 0;
 
Index: /trunk/gsdl/packages/mg-1.3d/src/text/WIN32.MAK
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/src/text/WIN32.MAK	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/src/text/WIN32.MAK	(revision 30)
@@ -14,5 +14,5 @@
 #CFLAGS = -g -O
 CPPFLAGS =
-DEFS = -DHAVE_CONFIG_H -D__WIN32__ -D_LITTLE_ENDIAN
+DEFS = -DNZDL -DQUIET -DSHORT_SUFFIX -DPARADOCNUM -DHAVE_CONFIG_H -D__WIN32__ -D_LITTLE_ENDIAN
 #INSTALL = /usr/local/gnu/bin/install -c
 #INSTALL_DATA = ${INSTALL} -m 644
@@ -78,5 +78,5 @@
   ivf.pass2.c             mg_text_estimate.c      text_get.c           \
   lists.c                 mg_text_merge.c         weights.c            \
-  query_term_list.c       mgpass.c                builder.cpp
+  mgpass.c                query_term_list.c       
 
 HEADERS = \
@@ -105,6 +105,6 @@
 		mg_hilite_words$e     mg_invf_merge$e \
 		mg_text_merge$e     bool_tester$e  mgpass$e \
-		mg_stem_idx$e  mgstemidxlist$e  mg_decompress_text$e \
-		builder$e
+		mg_stem_idx$e  mgstemidxlist$e \
+                mg_decompress_text$e
 
 MAN           = mgquery.1 mg_weights_build.1 mgstat.1 mg_invf_dump.1 mg_invf_dict.1 \
@@ -117,5 +117,5 @@
 
 
-all:    $(EXEC)
+all:    $(EXEC) libtextin.lib
 
 
@@ -253,6 +253,5 @@
 	$(LINK) $(PERF_HASH_OBJS) $(LIBS)
 
-STEM_IDX_OBJS = \
-                mg_stem_idx$o mg_files$o stemmer$o locallib$o \
+STEM_IDX_OBJS = mg_stem_idx$o mg_files$o stemmer$o locallib$o \
                 mg_errors$o term_lists$o
 
@@ -265,8 +264,7 @@
 	$(LINK) $(STEM_IDX_LIST_OBJS) $(LIBS)
 
-DECOMPRESS_TEXT_OBJS = \
-                mg_decompress_text$o mg_files$o mg_errors$o \
-                text_get$o locallib$o backend$o stem_search$o \
-                term_lists$o stemmer$o weights$o invf_get$o lists$o
+DECOMPRESS_TEXT_OBJS = mg_decompress_text$o query_term_list$o mg_files$o mg_errors$o \
+                       text_get$o locallib$o backend$o stem_search$o \
+                       term_lists$o stemmer$o weights$o invf_get$o lists$o
 
 mg_decompress_text$e: $(DECOMPRESS_TEXT_OBJS)
@@ -317,4 +315,17 @@
 
 
+LIB_OBJS = \
+	query_term_list$o \
+	locallib$o lists$o \
+	query.ranked$o query.docnums$o stem_search$o \
+	environment$o commands$o weights$o text_get$o stemmer$o \
+	read_line$o mg_errors$o backend$o invf_get$o \
+	term_lists$o bool_tree$o bool_parser$o bool_optimiser$o bool_query$o
+
+libtextin.lib: $(LIB_OBJS)
+	del libtextin.lib
+	lib /out:libtextin.lib $(LIB_OBJS)
+
+
 mostlyclean:
 	rm -f *$o _*.c _*.o *._c *._o core core.*
Index: /trunk/gsdl/packages/mg-1.3d/src/text/bool_parser.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/src/text/bool_parser.c	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/src/text/bool_parser.c	(revision 30)
@@ -1,6 +1,12 @@
 #ifndef lint
-static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
+static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
 #endif
 #define YYBYACC 1
+#define YYMAJOR 1
+#define YYMINOR 9
+#define yyclearin (yychar=(-1))
+#define yyerrok (yyerrflag=0)
+#define YYRECOVERING (yyerrflag!=0)
+#define YYPREFIX "yy"
 #line 25 "bool_parser.y"
  
@@ -46,5 +52,5 @@
   bool_tree_node *node;
 } YYSTYPE;
-#line 49 "y.tab.c"
+#line 55 "y.tab.c"
 #define TERM 257
 #define YYERRCODE 256
@@ -158,10 +164,7 @@
 };
 #endif
-#define yyclearin (yychar=(-1))
-#define yyerrok (yyerrflag=0)
 #ifdef YYSTACKSIZE
-#ifndef YYMAXDEPTH
+#undef YYMAXDEPTH
 #define YYMAXDEPTH YYSTACKSIZE
-#endif
 #else
 #ifdef YYMAXDEPTH
@@ -401,6 +404,7 @@
  
 
-#line 404 "y.tab.c"
+#line 407 "y.tab.c"
 #define YYABORT goto yyabort
+#define YYREJECT goto yyabort
 #define YYACCEPT goto yyaccept
 #define YYERROR goto yyerrlab
@@ -440,6 +444,6 @@
             if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
             if (!yys) yys = "illegal-symbol";
-            printf("yydebug: state %d, reading %d (%s)\n", yystate,
-                    yychar, yys);
+            printf("%sdebug: state %d, reading %d (%s)\n",
+                    YYPREFIX, yystate, yychar, yys);
         }
 #endif
@@ -450,6 +454,6 @@
 #if YYDEBUG
         if (yydebug)
-            printf("yydebug: state %d, shifting to state %d\n",
-                    yystate, yytable[yyn]);
+            printf("%sdebug: state %d, shifting to state %d\n",
+                    YYPREFIX, yystate, yytable[yyn]);
 #endif
         if (yyssp >= yyss + yystacksize - 1)
@@ -491,6 +495,6 @@
 #if YYDEBUG
                 if (yydebug)
-                    printf("yydebug: state %d, error recovery shifting\
- to state %d\n", *yyssp, yytable[yyn]);
+                    printf("%sdebug: state %d, error recovery shifting\
+ to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
 #endif
                 if (yyssp >= yyss + yystacksize - 1)
@@ -506,6 +510,6 @@
 #if YYDEBUG
                 if (yydebug)
-                    printf("yydebug: error recovery discarding state %d\n",
-                            *yyssp);
+                    printf("%sdebug: error recovery discarding state %d\n",
+                            YYPREFIX, *yyssp);
 #endif
                 if (yyssp <= yyss) goto yyabort;
@@ -524,6 +528,6 @@
             if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
             if (!yys) yys = "illegal-symbol";
-            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
-                    yystate, yychar, yys);
+            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
+                    YYPREFIX, yystate, yychar, yys);
         }
 #endif
@@ -534,6 +538,6 @@
 #if YYDEBUG
     if (yydebug)
-        printf("yydebug: state %d, reducing by rule %d (%s)\n",
-                yystate, yyn, yyrule[yyn]);
+        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
+                YYPREFIX, yystate, yyn, yyrule[yyn]);
 #endif
     yym = yylen[yyn];
@@ -577,5 +581,5 @@
 { yyval.node = CreateBoolTreeNode(N_or, yyvsp[-2].node, yyvsp[0].node); }
 break;
-#line 580 "y.tab.c"
+#line 584 "y.tab.c"
     }
     yyssp -= yym;
@@ -587,6 +591,6 @@
 #if YYDEBUG
         if (yydebug)
-            printf("yydebug: after reduction, shifting from state 0 to\
- state %d\n", YYFINAL);
+            printf("%sdebug: after reduction, shifting from state 0 to\
+ state %d\n", YYPREFIX, YYFINAL);
 #endif
         yystate = YYFINAL;
@@ -602,6 +606,6 @@
                 if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                 if (!yys) yys = "illegal-symbol";
-                printf("yydebug: state %d, reading %d (%s)\n",
-                        YYFINAL, yychar, yys);
+                printf("%sdebug: state %d, reading %d (%s)\n",
+                        YYPREFIX, YYFINAL, yychar, yys);
             }
 #endif
@@ -617,6 +621,6 @@
 #if YYDEBUG
     if (yydebug)
-        printf("yydebug: after reduction, shifting from state %d \
-to state %d\n", *yyssp, yystate);
+        printf("%sdebug: after reduction, shifting from state %d \
+to state %d\n", YYPREFIX, *yyssp, yystate);
 #endif
     if (yyssp >= yyss + yystacksize - 1)
Index: /trunk/gsdl/packages/mg-1.3d/src/text/mg_hilite_words.c
===================================================================
--- /trunk/gsdl/packages/mg-1.3d/src/text/mg_hilite_words.c	(revision 20)
+++ /trunk/gsdl/packages/mg-1.3d/src/text/mg_hilite_words.c	(revision 30)
@@ -628,5 +628,5 @@
  * ========================================================================= */
 
-void
+int
 main (int argc, char *argv[])
 {
@@ -684,3 +684,4 @@
 #endif
 
-}
+  return 0;
+}
Index: /trunk/gsdl/src/library/gdbmclass.cpp
===================================================================
--- /trunk/gsdl/src/library/gdbmclass.cpp	(revision 20)
+++ /trunk/gsdl/src/library/gdbmclass.cpp	(revision 30)
@@ -574,2 +574,113 @@
   return 1;
 }
+
+// functions related to sorting
+
+// returns whatever comes after ':#:' in str
+// -- this is a nasty hack that I'm sure Rodger will want to change ;-)
+text_t get_section_str(const text_t &str) {
+
+  text_t ret;
+  int found = 0;
+
+  text_t::const_iterator here = str.begin();
+  text_t::const_iterator end = str.end();
+
+  while (here != end) {
+    if (found) {
+      ret.push_back(*here);
+    } else {
+      here = findchar (here, end, ':');
+      if ((*(here+1) == '#') && (*(here+2) == ':')) {
+	found = 1;
+	here = here+2;
+      }
+    }
+    here ++;
+  }
+  return ret;
+}
+
+// removes leading spaces and leading 'the' 'a' and 'an' 
+// from string
+void alphabetize_string_english (text_t &text) {
+  
+  if (text.empty()) return;
+
+  text_t firstword;
+  char *word;
+
+  text_t::iterator here = text.begin();
+  text_t::const_iterator end = text.end();
+
+  if ((*here != ' ') && (*here != 'a') && (*here != 'A') &&
+      (*here != 't') && (*here != 'T')) return;
+
+  int foundchar = 0;
+  while (here != end) {
+    if (*here == ' ' && !foundchar) {here ++; continue;}
+    if (*here == ' ' && foundchar) {
+      text.erase(text.begin(), (here+1));
+      break;
+    }
+    foundchar ++;
+    if (foundchar == 1) {
+      getdelimitstr (here, end, ' ', firstword);
+      word = firstword.getcstr();
+      if ((_stricmp(word, "the") != 0) && (_stricmp(word, "a") != 0) &&
+	  (_stricmp(word, "an") != 0)) break;
+    }
+    here ++;
+  }
+  delete word;
+}
+
+// removes leading space, puts last name before 
+// any preceeding names
+void alphabetize_string_name (text_t &text) {
+  
+  if (text.empty()) return;
+  
+  text_t lastname;
+  char *lname;
+  vector<text_t> words;
+  splitchar (text.begin(), text.end(), ' ', words);
+  lastname = words.back();
+  words.pop_back();
+  lname = lastname.getcstr();
+  
+  while ((_stricmp(lname, "jnr") == 0) || (_stricmp(lname, "snr") == 0) ||
+	 (_stricmp(lname, "esq") == 0)) {
+    lastname = words.back();
+    words.pop_back();
+    lname = lastname.getcstr();
+  }
+
+  text.clear();
+  joinchar (words, ' ', text);
+  text = lastname + text;
+}
+
+char ** string_add (char **array, int *len, char *str) {
+  char **ret;
+
+  ret = (char**)realloc(array, (*len+1)*sizeof(char*));
+  ret[*len] = (char*)strdup(str);
+  (*len) ++;
+
+  return ret;
+}
+
+void string_sort (char **array, int len) {
+  qsort((void*)array, (unsigned int)(len), sizeof(char*), compare_str);
+}
+
+static int compare_str (const void *e1, const void *e2) {
+  return _stricmp(*((char**)e1), *((char**)e2));
+}
+
+void string_free(char **array, int len) {
+  for (int i = 0; i < len; i++)
+    free (array[i]);
+  free (array);
+}
Index: /trunk/gsdl/src/library/gdbmclass.h
===================================================================
--- /trunk/gsdl/src/library/gdbmclass.h	(revision 20)
+++ /trunk/gsdl/src/library/gdbmclass.h	(revision 30)
@@ -82,3 +82,10 @@
 void get_first_section(const text_t &instring, text_t &returnstring);
 int is_number (text_t &text);
+text_t get_section_str(const text_t &str);
+void alphabetize_string_english (text_t &text);
+void alphabetize_string_name (text_t &text);
+char ** string_add (char **array, int *len, char *str);
+void string_sort (char **array, int len);
+static int compare_str (const void *e1, const void *e2);
+void string_free(char **array, int len);
 #endif
